function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import AvatarEditor from 'react-avatar-editor';
import Button from '../Button';
import { Modal, ModalBody } from '../Modal';


var AvatarClip = /*#__PURE__*/function (_Component) {
  _inherits(AvatarClip, _Component);

  function AvatarClip() {
    var _this;

    _classCallCheck(this, AvatarClip);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AvatarClip).call(this));

    _defineProperty(_assertThisInitialized(_this), "setEditorRef", function (editor) {
      if (editor) _this.editor = editor;
    });

    _defineProperty(_assertThisInitialized(_this), "handleScale", function (e) {
      var scale = parseFloat(e.target.value);

      _this.setState({
        scale: scale
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      _this.props.onClose && _this.props.onClose();
    });

    _defineProperty(_assertThisInitialized(_this), "handleSave", function () {
      var img = _this.editor.getImageScaledToCanvas().toDataURL();

      _this.props.onSave(img);
    });

    _this.state = {
      scale: 1
    };
    return _this;
  }

  _createClass(AvatarClip, [{
    key: "render",
    // TODO: replace svg icon
    value: function render() {
      var _this$props = this.props,
          image = _this$props.image,
          width = _this$props.width,
          height = _this$props.height,
          border = _this$props.border,
          color = _this$props.color,
          cropButtonName = _this$props.cropButtonName,
          open = _this$props.open;
      return React.createElement(Modal, {
        open: open,
        onClose: this.handleClose,
        lock: true
      }, React.createElement(ModalBody, null, React.createElement("h3", {
        className: "".concat("waui", "-avatar-clip__title")
      }, "Edit Avatar"), React.createElement("div", {
        className: "".concat("waui", "-avatar-clip__subtitle")
      }, "Adjust avatar size and position"), React.createElement("div", {
        className: "".concat("waui", "-avatar-clip__content")
      }, React.createElement("div", {
        className: "".concat("waui", "-avatar-clip__edit")
      }, React.createElement(AvatarEditor, {
        ref: this.setEditorRef,
        image: image,
        width: width,
        height: height,
        border: border,
        color: color // RGBA
        ,
        scale: this.state.scale
      })), React.createElement("div", {
        className: "".concat("waui", "-avatar-clip__zoom")
      }, React.createElement("svg", {
        viewBox: "0 0 18 16",
        width: "14",
        height: "16",
        "aria-hidden": "true",
        style: {
          height: 16,
          width: 14
        }
      }, React.createElement("title", null), React.createElement("g", null, React.createElement("path", {
        d: "M13.296 3H1.006C.45 3 0 3.45 0 4.003v10.995C0 15.545.45 16 1.007 16h12.986C14.55 16 15 15.553 15 15V4.003C15 3.456 14.55 3 13.993 3h-.697zm-.892 11H2.596c-.33 0-.596-.266-.596-.6V5.6C2 5.27 2.267 5 2.596 5h9.81c.328 0 .595.266.595.6v7.8c0 .33-.268.6-.596.6zM4 0c-.552 0-1 .448-1 1s.448 1 1 1h11.5s.5 0 .5.5V12c0 .552.448 1 1 1s1-.448 1-1V1c0-.552-.448-1-1-1H4z",
        fillRule: "evenodd"
      }))), React.createElement("input", {
        type: "range",
        name: "scale",
        onChange: this.handleScale,
        min: "1",
        max: "2",
        step: "0.01",
        defaultValue: "1",
        className: "".concat("waui", "-avatar-clip__range-input")
      }), React.createElement("svg", {
        viewBox: "0 0 18 16",
        width: "21",
        height: "16",
        "aria-hidden": "true",
        style: {
          height: 16,
          width: 21
        }
      }, React.createElement("title", null), React.createElement("g", null, React.createElement("path", {
        d: "M13.296 3H1.006C.45 3 0 3.45 0 4.003v10.995C0 15.545.45 16 1.007 16h12.986C14.55 16 15 15.553 15 15V4.003C15 3.456 14.55 3 13.993 3h-.697zm-.892 11H2.596c-.33 0-.596-.266-.596-.6V5.6C2 5.27 2.267 5 2.596 5h9.81c.328 0 .595.266.595.6v7.8c0 .33-.268.6-.596.6zM4 0c-.552 0-1 .448-1 1s.448 1 1 1h11.5s.5 0 .5.5V12c0 .552.448 1 1 1s1-.448 1-1V1c0-.552-.448-1-1-1H4z",
        fillRule: "evenodd"
      })))), React.createElement("div", {
        className: "".concat("waui", "-avatar-clip__footer")
      }, React.createElement(Button, {
        type: "primary",
        onClick: this.handleSave,
        block: true,
        ghost: true
      }, cropButtonName)))));
    }
  }]);

  return AvatarClip;
}(Component);

AvatarClip.propTypes = {
  /** The url of image */
  image: PropTypes.string.isRequired,

  /** The callback of saving avatar */
  onSave: PropTypes.func.isRequired,

  /** The callback of closing avatar */
  onClose: PropTypes.func,

  /** Whether to open the modal of cropping avatar */
  open: PropTypes.bool,

  /** The name of the button for cropping */
  cropButtonName: PropTypes.string,

  /** The width of cropping */
  width: PropTypes.number,

  /** The height of cropping */
  height: PropTypes.number,

  /** The border of mask for cropping */
  border: PropTypes.number,

  /** The color of text for cropping */
  color: PropTypes.arrayOf(PropTypes.number)
};
AvatarClip.defaultProps = {
  width: 160,
  height: 160,
  border: 40,
  color: [248, 249, 250, 0.9],
  cropButtonName: 'SAVE'
};
export default AvatarClip;