import cx from 'classnames';
import PropTypes from 'prop-types';
import React from 'react';
import Button from '../Button';
export default function NavBottom(_ref) {
  var user = _ref.user,
      onSettingClick = _ref.onSettingClick,
      onLogoutClick = _ref.onLogoutClick;
  return React.createElement("div", {
    className: "".concat("waui", "-nav__bottom")
  }, React.createElement("div", {
    className: "".concat("waui", "-nav__bottom-image")
  }, React.createElement("img", {
    className: "".concat("waui", "-nav__bottom-image-icon"),
    src: user === null || user === void 0 ? void 0 : user.avatar,
    alt: "Avatar"
  })), React.createElement("div", {
    className: "".concat("waui", "-nav__bottom-user")
  }, React.createElement("span", {
    className: "".concat("waui", "-nav__bottom-user-name")
  }, user === null || user === void 0 ? void 0 : user.name), React.createElement("span", {
    className: "".concat("waui", "-nav__bottom-user-company")
  }, user === null || user === void 0 ? void 0 : user.company)), React.createElement("div", {
    className: "".concat("waui", "-nav__bottom-logout")
  }, React.createElement(Button, {
    icon: "logout",
    onClick: function onClick(e) {
      return onLogoutClick(e);
    },
    className: cx("".concat("waui", "-nav__btn-icon"), "".concat("waui", "-nav__bottom-logout-icon"))
  })), React.createElement("div", {
    className: "".concat("waui", "-nav__bottom-settings")
  }, React.createElement(Button, {
    icon: "settings",
    onClick: function onClick(e) {
      return onSettingClick(e);
    },
    className: cx("".concat("waui", "-nav__btn-icon"), "".concat("waui", "-nav__bottom-settings-icon"))
  })));
}
NavBottom.propTypes = {
  user: PropTypes.shape({
    avatar: PropTypes.string,
    name: PropTypes.string,
    company: PropTypes.string
  }),
  onSettingClick: PropTypes.func,
  onLogoutClick: PropTypes.func
};