"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Icon = _interopRequireDefault(require("../Icon"));



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Button(props) {
  var _cx;

  var children = props.children,
      className = props.className,
      type = props.type,
      loading = props.loading,
      size = props.size,
      block = props.block,
      ghost = props.ghost,
      icon = props.icon,
      disabled = props.disabled,
      other = _objectWithoutProperties(props, ["children", "className", "type", "loading", "size", "block", "ghost", "icon", "disabled"]);

  var classNames = (0, _classnames["default"])("".concat("waui", "-button"), (_cx = {}, _defineProperty(_cx, "".concat("waui", "-button--").concat(type), type), _defineProperty(_cx, "".concat("waui", "-button--").concat(size), size), _defineProperty(_cx, "".concat("waui", "-button--ghost"), ghost), _defineProperty(_cx, "".concat("waui", "-button--loading"), loading), _defineProperty(_cx, "".concat("waui", "-button--block"), block), _defineProperty(_cx, "".concat("waui", "-button__icon-only"), icon && !children), _cx), className);

  if (icon && children) {
    return _react["default"].createElement("button", _extends({
      type: "button",
      className: classNames,
      disabled: disabled || loading
    }, other), _react["default"].createElement("div", null, _react["default"].createElement(_Icon["default"], {
      type: icon
    }), _react["default"].createElement("span", null, children)));
  }

  return _react["default"].createElement("button", _extends({
    type: "button",
    className: classNames,
    disabled: disabled || loading
  }, other), icon && _react["default"].createElement(_Icon["default"], {
    type: icon
  }), children && _react["default"].createElement("span", null, children));
}

Button.propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /** button type */
  type: _propTypes["default"].oneOf(['primary', 'accept', 'warning', 'danger', 'link', 'text']),

  /** button size */
  size: _propTypes["default"].oneOf(['sm', 'md', 'lg']),

  /** determine whether it's a ghost button */
  ghost: _propTypes["default"].bool,

  /** determine whether it's a block button */
  block: _propTypes["default"].bool,

  /** determine whether it's loading */
  loading: _propTypes["default"].bool,

  /** disable the button */
  disabled: _propTypes["default"].bool,

  /** icon type name */
  icon: _propTypes["default"].string
};
Button.defaultProps = {
  size: 'md'
};
var _default = Button;
exports["default"] = _default;