"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Input = _interopRequireDefault(require("../../Input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var FormInput = function FormInput(props, context) {
  var children = props.children,
      className = props.className,
      onChange = props.onChange,
      other = _objectWithoutProperties(props, ["children", "className", "onChange"]);

  var form = context.form,
      formItem = context.formItem;
  other.value = form.getItemValue(formItem);

  other.onChange = function (value) {
    form.setItemValue(formItem, value);
    onChange && onChange(value);
  };

  return _react["default"].createElement(_Input["default"], _extends({
    className: (0, _classnames["default"])("".concat("waui", "-form__input"), className)
  }, other));
};

FormInput.propTypes = {
  onChange: _propTypes["default"].func,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string
};
FormInput.contextTypes = {
  form: _propTypes["default"].object.isRequired,
  formItem: _propTypes["default"].object.isRequired
};
var _default = FormInput;
exports["default"] = _default;