"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

var _Scrollbar = _interopRequireDefault(require("../Scrollbar"));

var _MenuIcon = require("./MenuIcon");

var _NavBottom = _interopRequireDefault(require("./NavBottom"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Nav = /*#__PURE__*/function (_Component) {
  _inherits(Nav, _Component);

  function Nav(props) {
    var _this;

    _classCallCheck(this, Nav);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Nav).call(this, props));
    _this.state = {
      selectedId: props.selectedId || '',
      collapsed: _this.props.collapsed,
      collapsedTrigger: ''
    };
    return _this;
  }

  _createClass(Nav, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        nav: this
      };
    }
  }, {
    key: "handleItemClick",
    value: function handleItemClick(props, e) {
      this.setState({
        selectedId: props.id
      });
      this.props.onItemClick && this.props.onItemClick(props, e);
    }
  }, {
    key: "handleCollapseToggle",
    value: function handleCollapseToggle(collapsed) {
      this.setState({
        collapsed: collapsed,
        collapsedTrigger: collapsed ? 'close-icon' : 'menu-icon'
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var collapsed = this.state.collapsed;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          width = _this$props.width,
          logoUrl = _this$props.logoUrl,
          user = _this$props.user,
          onSettingClick = _this$props.onSettingClick,
          onLogoutClick = _this$props.onLogoutClick,
          other = _objectWithoutProperties(_this$props, ["children", "className", "width", "logoUrl", "user", "onSettingClick", "onLogoutClick"]);

      delete other.selectedId;
      delete other.onItemClick;
      delete other.user;
      delete other.collapsed;

      if (width) {
        if (collapsed) {
          var _other$style;

          other === null || other === void 0 ? true : (_other$style = other.style) === null || _other$style === void 0 ? true : delete _other$style.width;
        } else {
          other.style = Object.assign(other.style || {}, {
            width: width
          });
        }
      }

      return _react["default"].createElement("div", _extends({
        className: (0, _classnames["default"])("".concat("waui", "-nav"), _defineProperty({}, "".concat("waui", "-nav--collapsed"), collapsed), className)
      }, other), _react["default"].createElement("div", {
        className: "".concat("waui", "-nav__top")
      }, _react["default"].createElement("div", {
        className: "".concat("waui", "-nav__top-left-container"),
        onClick: function onClick() {
          return _this2.handleCollapseToggle(false);
        }
      }, _react["default"].createElement(_MenuIcon.MenuIcon, {
        className: "".concat("waui", "-nav__top-left-container-menu-icon")
      })), _react["default"].createElement("div", {
        className: "".concat("waui", "-nav__top-center-container")
      }, _react["default"].createElement("img", {
        className: "".concat("waui", "-nav__top-center-container-logo"),
        src: logoUrl,
        alt: "Logo"
      })), _react["default"].createElement("div", {
        className: "".concat("waui", "-nav__top-right-container")
      }, _react["default"].createElement(_Button["default"], {
        className: (0, _classnames["default"])("".concat("waui", "-nav__btn-icon"), "".concat("waui", "-nav__top-right-container-close-icon")),
        onClick: function onClick() {
          return _this2.handleCollapseToggle(true);
        },
        icon: "close"
      }))), _react["default"].createElement(_Scrollbar["default"], {
        className: "".concat("waui", "-nav__scrollbar")
      }, _react["default"].createElement("ul", null, children)), _react["default"].createElement(_NavBottom["default"], {
        user: user,
        onSettingClick: onSettingClick,
        onLogoutClick: onLogoutClick
      }));
    }
  }]);

  return Nav;
}(_react.Component);

Nav.childContextTypes = {
  nav: _propTypes["default"].instanceOf(Nav)
};
Nav.propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /** The id of active nav item */
  selectedId: _propTypes["default"].string.isRequired,

  /** The url of logo image such as svg, png */
  logoUrl: _propTypes["default"].string,

  /** Whether the navigation is collapsed */
  collapsed: _propTypes["default"].bool,

  /** The width of expanded navigation, default value is `330px` */
  width: _propTypes["default"].number,

  /** User information */
  user: _propTypes["default"].shape({
    avatar: _propTypes["default"].string,
    name: _propTypes["default"].string,
    company: _propTypes["default"].string
  }),

  /** The click event of each NavItem, the parameters are the current NavItem props and event object */
  onItemClick: _propTypes["default"].func,

  /** The click event of setting button */
  onSettingClick: _propTypes["default"].func,

  /** The click event of logout button */
  onLogoutClick: _propTypes["default"].func
};
Nav.defaultProps = {
  collapsed: true
};
var _default = Nav;
exports["default"] = _default;