"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = NavBottom;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("../Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function NavBottom(_ref) {
  var user = _ref.user,
      onSettingClick = _ref.onSettingClick,
      onLogoutClick = _ref.onLogoutClick;
  return _react["default"].createElement("div", {
    className: "".concat("waui", "-nav__bottom")
  }, _react["default"].createElement("div", {
    className: "".concat("waui", "-nav__bottom-image")
  }, _react["default"].createElement("img", {
    className: "".concat("waui", "-nav__bottom-image-icon"),
    src: user === null || user === void 0 ? void 0 : user.avatar,
    alt: "Avatar"
  })), _react["default"].createElement("div", {
    className: "".concat("waui", "-nav__bottom-user")
  }, _react["default"].createElement("span", {
    className: "".concat("waui", "-nav__bottom-user-name")
  }, user === null || user === void 0 ? void 0 : user.name), _react["default"].createElement("span", {
    className: "".concat("waui", "-nav__bottom-user-company")
  }, user === null || user === void 0 ? void 0 : user.company)), _react["default"].createElement("div", {
    className: "".concat("waui", "-nav__bottom-logout")
  }, _react["default"].createElement(_Button["default"], {
    icon: "logout",
    onClick: function onClick(e) {
      return onLogoutClick(e);
    },
    className: (0, _classnames["default"])("".concat("waui", "-nav__btn-icon"), "".concat("waui", "-nav__bottom-logout-icon"))
  })), _react["default"].createElement("div", {
    className: "".concat("waui", "-nav__bottom-settings")
  }, _react["default"].createElement(_Button["default"], {
    icon: "settings",
    onClick: function onClick(e) {
      return onSettingClick(e);
    },
    className: (0, _classnames["default"])("".concat("waui", "-nav__btn-icon"), "".concat("waui", "-nav__bottom-settings-icon"))
  })));
}

NavBottom.propTypes = {
  user: _propTypes["default"].shape({
    avatar: _propTypes["default"].string,
    name: _propTypes["default"].string,
    company: _propTypes["default"].string
  }),
  onSettingClick: _propTypes["default"].func,
  onLogoutClick: _propTypes["default"].func
};