"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function getDocumentScroll() {
  var _document = document,
      documentElement = _document.documentElement,
      body = _document.body;
  return [documentElement && documentElement.scrollTop || body.scrollTop, documentElement && documentElement.scrollLeft || body.scrollLeft];
}

function CoordinateFactory(triggerNode, popoverNode, direction, align) {
  var _getDocumentScroll = getDocumentScroll(),
      _getDocumentScroll2 = _slicedToArray(_getDocumentScroll, 2),
      scrollTop = _getDocumentScroll2[0],
      scrollLeft = _getDocumentScroll2[1];

  var CF = CoordinateFactory;
  CF.triggerRect = triggerNode.getBoundingClientRect();
  CF.popoverRect = popoverNode.getBoundingClientRect();
  CF.direction = CF.getComputedDirection(direction);
  CF.align = CF.getComputedAlign(align);
  CF.center = [CF.triggerRect.left + CF.triggerRect.width / 2 + scrollLeft, CF.triggerRect.top + CF.triggerRect.height / 2 + scrollTop];

  var _CF$coordinateMap$CF$ = CF.coordinateMap[CF.direction].call(CF),
      _CF$coordinateMap$CF$2 = _slicedToArray(_CF$coordinateMap$CF$, 2),
      left = _CF$coordinateMap$CF$2[0],
      top = _CF$coordinateMap$CF$2[1];

  popoverNode.style.left = left + 'px';
  popoverNode.style.top = top + 'px';
  return [CF.direction, CF.align];
}

Object.assign(CoordinateFactory, {
  triggerRect: null,
  popoverRect: null,
  align: null,
  center: null,
  getComputedDirection: function getComputedDirection(direction) {
    var triggerRect = this.triggerRect,
        popoverRect = this.popoverRect;

    if (direction === 'up' || direction === 'down') {
      if (triggerRect.top < popoverRect.height) {
        direction = 'down';
      } else if (popoverRect.height + triggerRect.top + triggerRect.height > window.innerHeight) {
        direction = 'up';
      }
    }

    return direction;
  },
  getComputedAlign: function getComputedAlign(align) {
    if (align === 'middle') {
      return align;
    }

    if (this.direction === 'up' || this.direction === 'down') {
      if (align === 'top' || align === 'bottom') {
        return 'middle';
      }
    } else {
      if (align === 'left' || align === 'right') {
        return 'middle';
      }
    }

    return align;
  },
  getAlignPosition: function getAlignPosition(horizontal) {
    var types = horizontal ? ['left', 'right'] : ['top', 'bottom'];
    var axis = horizontal ? 0 : 1;
    var size = horizontal ? 'width' : 'height';

    if (this.align === types[0]) {
      return this.center[axis] - this.triggerRect[size] / 2;
    } else if (this.align === types[1]) {
      return this.center[axis] - this.popoverRect[size] + this.triggerRect[size] / 2;
    } else {
      return this.center[axis] - this.popoverRect[size] / 2;
    }
  },
  coordinateMap: {
    up: function up() {
      var top = this.center[1] - this.triggerRect.height / 2 - this.popoverRect.height;
      return [this.getAlignPosition(true), top];
    },
    down: function down() {
      var top = this.center[1] + this.triggerRect.height / 2;
      return [this.getAlignPosition(true), top];
    },
    left: function left() {
      var left = this.center[0] - this.triggerRect.width / 2 - this.popoverRect.width;
      return [left, this.getAlignPosition()];
    },
    right: function right() {
      var left = this.center[0] + this.triggerRect.width / 2;
      return [left, this.getAlignPosition()];
    }
  }
});
var _default = CoordinateFactory;
exports["default"] = _default;