"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _TextOverflow = _interopRequireDefault(require("../../TextOverflow"));

var _Icon = _interopRequireDefault(require("../../Icon"));



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Option = function Option(props) {
  var _cx;

  var children = props.children,
      className = props.className,
      data = props.data,
      value = props.value,
      selected = props.selected,
      active = props.active,
      other = _objectWithoutProperties(props, ["children", "className", "data", "value", "selected", "active"]);

  var classNames = (0, _classnames["default"])("".concat("waui", "-select__option"), (_cx = {}, _defineProperty(_cx, "".concat("waui", "-select__option_active"), active), _defineProperty(_cx, "".concat("waui", "-select__option_selected"), selected), _cx), className);
  return _react["default"].createElement("li", _extends({
    className: classNames
  }, other), _react["default"].createElement(_TextOverflow["default"], null, _react["default"].createElement("div", null, children)), selected && _react["default"].createElement(_Icon["default"], {
    type: "check",
    className: "".concat("waui", "-select__option-icon_selected")
  }));
};

Option.propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  data: _propTypes["default"].object,

  /** 值，与 Select value 对应，数据类型也要一致 */
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  selected: _propTypes["default"].bool,
  active: _propTypes["default"].bool
};
var _default = Option;
exports["default"] = _default;