"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Popover = _interopRequireDefault(require("../Popover"));



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Tooltip = function Tooltip(props) {
  var children = props.children,
      className = props.className,
      title = props.title,
      other = _objectWithoutProperties(props, ["children", "className", "title"]);

  return _react["default"].createElement(_Popover["default"], _extends({
    className: (0, _classnames["default"])("".concat("waui", "-tooltip__popover"), className),
    content: title
  }, other), children);
};

Tooltip.defaultProps = {
  triggerMode: 'hover',
  direction: 'up',
  align: 'middle'
};
Tooltip.propTypes = {
  className: _propTypes["default"].string,
  children: _propTypes["default"].element.isRequired,

  /** The title of tooltips */
  title: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].element]),

  /** The mode of triggering tooltips */
  triggerMode: _propTypes["default"].oneOf(['hover', 'click']),

  /** The direction of tooltips */
  direction: _propTypes["default"].oneOf(['up', 'down', 'left', 'right']),

  /** The alignment of tooltips */
  align: _propTypes["default"].oneOf(['top', 'right', 'bottom', 'left', 'middle'])
};
var _default = Tooltip;
exports["default"] = _default;