"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

function _default(validator) {
  var callbackName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'onChange';
  return function (props, propName, componentName) {
    if (propName in props && !props[callbackName] && !props.disabled) {
      return new Error("You provided a `".concat(propName, "` prop to `").concat(componentName, "` without an `").concat(callbackName, "` handler."));
    }

    return validator.apply(void 0, arguments);
  };
}