"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Button = _interopRequireDefault(require("../Button"));

var _config = require("./config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DialogButtons = /*#__PURE__*/function (_React$Component) {
  _inherits(DialogButtons, _React$Component);

  function DialogButtons(_props) {
    var _this;

    _classCallCheck(this, DialogButtons);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DialogButtons).call(this));

    _defineProperty(_assertThisInitialized(_this), "handleClose", function () {
      var _this$context, _this$context$dialog, _this$context$dialog$, _this$props, _this$props$onClose;

      (_this$context = _this.context) === null || _this$context === void 0 ? void 0 : (_this$context$dialog = _this$context.dialog) === null || _this$context$dialog === void 0 ? void 0 : (_this$context$dialog$ = _this$context$dialog.close) === null || _this$context$dialog$ === void 0 ? void 0 : _this$context$dialog$.call(_this$context$dialog);
      (_this$props = _this.props) === null || _this$props === void 0 ? void 0 : (_this$props$onClose = _this$props.onClose) === null || _this$props$onClose === void 0 ? void 0 : _this$props$onClose.call(_this$props);

      _this.setState({
        open: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAcceptClick", function () {
      _this.handleClose();

      setTimeout(function () {
        var _this$props2, _this$props2$onAccept;

        return (_this$props2 = _this.props) === null || _this$props2 === void 0 ? void 0 : (_this$props2$onAccept = _this$props2.onAccept) === null || _this$props2$onAccept === void 0 ? void 0 : _this$props2$onAccept.call(_this$props2);
      }, 400);
    });

    _defineProperty(_assertThisInitialized(_this), "handleCancelClick", function () {
      _this.handleClose();

      setTimeout(function () {
        var _this$props3, _this$props3$onCancel;

        return (_this$props3 = _this.props) === null || _this$props3 === void 0 ? void 0 : (_this$props3$onCancel = _this$props3.onCancel) === null || _this$props3$onCancel === void 0 ? void 0 : _this$props3$onCancel.call(_this$props3);
      }, 400);
    });

    _defineProperty(_assertThisInitialized(_this), "renderButtons", function (props) {
      var _typeMap$type;

      var className = props.className,
          acceptLabel = props.acceptLabel,
          cancelLabel = props.cancelLabel,
          type = props.type;
      return _react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat("waui", "-dialog__main-buttons"), className)
      }, !!acceptLabel && _react["default"].createElement(_Button["default"], {
        type: ((_typeMap$type = _config.typeMap[type]) === null || _typeMap$type === void 0 ? void 0 : _typeMap$type.btnType) || 'secondary',
        onClick: _this.handleAcceptClick,
        block: true
      }, acceptLabel), !!cancelLabel && _react["default"].createElement(_Button["default"], {
        onClick: _this.handleCancelClick,
        block: true
      }, cancelLabel));
    });

    _this.state = {
      open: true
    };
    return _this;
  }

  _createClass(DialogButtons, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.state.open === false && this.setState({
        open: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      return this.state.open ? _react["default"].createElement("div", null, this.renderButtons(this.props)) : this.renderButtons(this.props);
    }
  }]);

  return DialogButtons;
}(_react["default"].Component);

_defineProperty(DialogButtons, "contextTypes", {
  dialog: _propTypes["default"].object
});

_defineProperty(DialogButtons, "propTypes", {
  className: _propTypes["default"].string,
  acceptLabel: _propTypes["default"].string,
  cancelLabel: _propTypes["default"].string,
  type: _propTypes["default"].oneOf(['confirm', 'accept', 'warning', 'danger', 'success', 'info', 'error']),
  onClose: _propTypes["default"].func,
  onAccept: _propTypes["default"].func,
  onCancel: _propTypes["default"].func
});

var _default = DialogButtons;
exports["default"] = _default;