"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _marked = _interopRequireDefault(require("marked"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Dialog = _interopRequireDefault(require("../dialog/Dialog"));

var _DialogBody = _interopRequireDefault(require("../dialog/DialogBody"));

var _DialogButtons = _interopRequireDefault(require("../dialog/DialogButtons"));

var _DialogHeader = _interopRequireDefault(require("../dialog/DialogHeader"));



function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Notification = /*#__PURE__*/function (_React$Component) {
  _inherits(Notification, _React$Component);

  function Notification() {
    var _this;

    _classCallCheck(this, Notification);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Notification).call(this));

    _defineProperty(_assertThisInitialized(_this), "handleDialogClose", function () {
      var _this$props, _this$props$onClose;

      _this.setState({
        isOpen: false
      });

      (_this$props = _this.props) === null || _this$props === void 0 ? void 0 : (_this$props$onClose = _this$props.onClose) === null || _this$props$onClose === void 0 ? void 0 : _this$props$onClose.call(_this$props);
    });

    _this.state = {
      isOpen: true
    };
    return _this;
  }

  _createClass(Notification, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          backdrop = _this$props2.backdrop,
          lock = _this$props2.lock,
          type = _this$props2.type,
          options = _this$props2.options,
          acceptLabel = _this$props2.acceptLabel,
          message = _this$props2.message,
          autoClose = _this$props2.autoClose,
          duration = _this$props2.duration;
      return _react["default"].createElement("div", null, !!this.state.isOpen && _react["default"].createElement(_Dialog["default"], {
        type: "notification",
        onClose: this.handleDialogClose,
        backdrop: backdrop,
        lock: lock,
        autoClose: autoClose,
        duration: duration
      }, _react["default"].createElement(_DialogHeader["default"], {
        type: type,
        icon: options === null || options === void 0 ? void 0 : options.icon
      }), _react["default"].createElement(_DialogBody["default"], null, _react["default"].createElement("div", {
        className: (0, _classnames["default"])("".concat("waui", "-dialog__body-markdown"), _defineProperty({}, "".concat("waui", "-dialog__body-markdown_success"), type === 'success')),
        dangerouslySetInnerHTML: {
          __html: (0, _marked["default"])(message)
        }
      })), !!acceptLabel && _react["default"].createElement(_DialogButtons["default"], _extends({
        type: type,
        focused: options === null || options === void 0 ? void 0 : options.focused,
        acceptLabel: acceptLabel
      }, options))));
    }
  }]);

  return Notification;
}(_react["default"].Component);

var _default = Notification;
exports["default"] = _default;